diff --git a/contrib/ntp/sntp/m4/ntp_openssl.m4 b/contrib/ntp/sntp/m4/ntp_openssl.m4
index 2f9d6c4318ad..74cfdf08b749 100644
--- a/contrib/ntp/sntp/m4/ntp_openssl.m4
+++ b/contrib/ntp/sntp/m4/ntp_openssl.m4
@@ -2,18 +2,22 @@ dnl ####################################################################
 dnl OpenSSL support shared by top-level and sntp/configure.ac
 dnl
 dnl Provides command-line option --with-crypto, as well as deprecated
-dnl options --with-openssl-incdir, --with-openssl-libdir, and the
-dnl latter's suboption --with-rpath.
+dnl options --with-openssl-incdir, --with-openssl-libdir..
 dnl
-dnl Specifying --with-openssl-libdir or --with-openssl-incdir causes any
-dnl pkg-config openssl information to be ignored in favor of the legacy
-dnl manual search for directories and specified library names.
+dnl Specifying --with-openssl-libdir or --with-openssl-incdir skips
+dnl pkg-config search.
+dnl
+dnl In the past, use of crypto would be silently disabled if the needed
+dnl headers and library were not found.  Now --without-crypto must be
+dnl used or configure will fail with an error.  It is now uncommon
+dnl to want to build ntpd without crypto, so don't be quiet about it.
 dnl
 dnl Output AC_DEFINEs (for config.h)
 dnl	OPENSSL		defined only if using OpenSSL
 dnl
 dnl Output variables:
 dnl	ntp_openssl	yes if using OpenSSL, no otherwise
+dnl	VER_SUFFIX	"o" if using OpenSSL
 dnl
 dnl Output substitutions:
 dnl	CFLAGS_NTP	OpenSSL-specific flags added as needed, and
@@ -22,19 +26,29 @@ dnl			trigger a flood of warnings for each file
 dnl			including OpenSSL headers.
 dnl	CPPFLAGS_NTP	OpenSSL -Iincludedir flags added as needed.
 dnl	LDADD_NTP	OpenSSL -L and -l flags added as needed.
-dnl	LDFLAGS_NTP	Other OpenSSL link flags added as needed.
+dnl	LDFLAGS_NTP	OpenSSL runpath flags as needed.
 dnl
 dnl ####################################################################
+dnl
 AC_DEFUN([NTP_OPENSSL], [
+AC_REQUIRE([AC_PROG_SED])dnl
 AC_REQUIRE([NTP_PKG_CONFIG])dnl
 AC_REQUIRE([NTP_VER_SUFFIX])dnl
+AC_REQUIRE([NTP_OPENSSL_VERBOSE_MSG])dnl
 
 AC_ARG_WITH(
     [crypto],
     [AS_HELP_STRING(
 	[--with-crypto],
 	[+ =openssl,libcrypto]
-    )]
+    )],
+    [	dnl if given
+	case "$with_crypto" in
+	 yes)
+	    with_crypto=openssl,libcrypto
+	esac
+    ],
+    [with_crypto=openssl,libcrypto]	dnl if not given
 )
 AC_ARG_WITH(
     [openssl-libdir],
@@ -47,42 +61,180 @@ AC_ARG_WITH(
     [openssl-incdir],
     [AS_HELP_STRING(
 	[--with-openssl-incdir],
-	[+ =/something/reasonable]
+	[+ =search likely dirs]
     )]
 )
-AC_ARG_WITH(
-    [rpath],
+AC_ARG_ENABLE(
+    [verbose-ssl],
     [AS_HELP_STRING(
-	[--without-rpath],
-	[s Disable auto-added -R linker paths]
-    )]
+	[--enable-verbose-ssl],
+	[- show crypto lib detection details]
+    )],
+    [],
+    [enable_verbose_ssl=no]	dnl default to quiet
 )
 
 ntp_openssl=no
 ntp_openssl_from_pkg_config=no
+ntp_ssl_incdir=
+ntp_ssl_cflags=
+ntp_ssl_cppflags=
+ntp_ssl_libdir=
+ntp_ssl_libs_L=
+ntp_ssl_libs_l=
+ntp_ssl_libs=
+ntp_ssl_ldflags=
 
-with_crypto=${with_crypto:-openssl,libcrypto}
-case "$with_crypto" in
- yes)
-    with_crypto=openssl,libcrypto
-esac
+NTPSSL_SAVED_CFLAGS="$CFLAGS"
+NTPSSL_SAVED_CPPFLAGS="$CPPFLAGS"
+NTPSSL_SAVED_LIBS="$LIBS"
+NTPSSL_SAVED_LDFLAGS="$LDFLAGS"
 
-dnl AC_MSG_NOTICE(['%with_crypto:%{PKG_CONFIG:+notempty}:%{with_openssl_libdir-notgiven}:%{with_openssl_incdir-notgiven}'])
-dnl str="$with_crypto:${PKG_CONFIG:+notempty}:${with_openssl_libdir-notgiven}:${with_openssl_incdir-notgiven}"
-dnl AC_MSG_NOTICE([$str])
+AC_PATH_PROG([PATH_OPENSSL], [openssl])
 
+str="$with_crypto:${PKG_CONFIG:+notempty}:${with_openssl_libdir-notgiven}:${with_openssl_incdir-notgiven}"
+NTP_OPENSSL_VERBOSE_MSG([$str])
+AS_UNSET([str])
+
+# Make sure neither/both --with_openssl-{inc,lib}dir are given
+case "${with_openssl_libdir-notgiven}:${with_openssl_incdir-notgiven}" in
+ notgiven:notgiven) ;;
+ *notgiven*)
+    AC_MSG_ERROR([only one of --with-openssl-{inc,lib}dir=... given - provide both or neither])
+    ;;
+esac
+
+# HMS: Today there are only 2 case options.  We probably want a third
+# *:*:notgiven:notgiven
+# and in that case we would validate the path in PKG_CONFIG_PATH.
+# Unless we can do it with 2 cases, where the 2nd case is *:*:...
+# and we do a reality check on execpath and the headers/libraries.
+#
+##
+# if $with_crypto is not "no":
+#   if --with-openssl-{inc,lib}dir are not given:
+#     we should use pkg-config to find openssl
+#     if we don't have pkg-config, if openssl is in the base OS, use that.
+##
 case "$with_crypto:${PKG_CONFIG:+notempty}:${with_openssl_libdir-notgiven}:${with_openssl_incdir-notgiven}" in
  no:*) ;;
  *:notempty:notgiven:notgiven)
-    for pkg in `echo $with_crypto | sed -e 's/,/ /'`; do
+    # If PKG_CONFIG is notempty and we haven't been given openssl paths,
+    # then let's make sure that the openssl executable's path corresponds
+    # to the path in openssl.pc, and 'openssl version' matches the Version
+    # in openssl.pc.  If $PKG_CONFIG tells us an INCPATH and/or a LIBPATH,
+    # then should we reality check them?
+    ## INCPATH
+    # harlan@ntp-testbuild.tal1> openssl version
+    # OpenSSL 1.1.1t  7 Feb 2023
+    # harlan@ntp-testbuild.tal1> grep 1.1.1t /ntpbuild/include/openssl/*
+    # /ntpbuild/include/openssl/opensslv.h:# define OPENSSL_VERSION_TEXT    "OpenSSL 1.1.1t  7 Feb 2023"
+    # harlan@ntp-testbuild.tal1>
+    ## LIBPATH
+    # harlan@ntp-testbuild.tal1> strings -a /ntpbuild/lib/libcrypto.* | fgrep 1.1.1t
+    # OpenSSL 1.1.1t  7 Feb 2023
+    # OpenSSL 1.1.1t  7 Feb 2023
+    # OpenSSL 1.1.1t  7 Feb 2023
+    # harlan@ntp-testbuild.tal1> ls /ntpbuild/lib/libcrypto.*
+    # /ntpbuild/lib/libcrypto.a       /ntpbuild/lib/libcrypto.so.1.1*
+    # /ntpbuild/lib/libcrypto.so@
+    # harlan@ntp-testbuild.tal1>
+    ##
+    # Having said this, do we really care if the openssl executable that
+    # we have found is matched with the INCPATH and LIBPATH?
+    # One answer: Probably not, but we should complain on a mismatch as
+    # otherwise runtime differences could easily cause problems/drama.
+
+    ##BO
+    # ntp_cv_build_framework_help=yes
+    save_PKG_CONFIG_PATH=${PKG_CONFIG_PATH}
+    for pkg in `echo $with_crypto | $SED -e 's/,/ /'`; do
+        case "$pkg" in
+	 openssl)
+	    if $PKG_CONFIG --exists $pkg ; then
+		# Found it - yay
+		# Do we want to check we found the right one?
+		# --modver
+		# --variable={libdir,includedir} (varname)
+		overf=`openssl version`
+		overs=`echo $overf | awk '{print $2}'`
+		case "$overs" in
+		 0.*) ;;	# Should we squawk?
+		 1.0.*) ;;	# Should we squawk?
+		 1.1.*) ;;	# Should we squawk?
+		 3.*)
+		    oinc=`openssl --variable=includedir`
+		    olib=`openssl --variable=libdir`
+		    # How should we use these?
+		    ;;
+		 *) ;;	# Should we squawk?
+		esac
+		# /ntpbuild/include/openssl/opensslv.h:# define OPENSSL_VERSION_TEXT    "OpenSSL 1.1.1t  7 Feb 2023"
+		# grep 1.1.1t /ntpbuild/lib/libcrypto.a
+		# strings -a /ntpbuild/lib/libcrypto.a | grep 1.1.1t
+		# OpenSSL 1.1.1t  7 Feb 2023
+		# harlan@ntp-testbuild.tal1>
+		# which should match $overf
+		##
+		# harlan@ntp-testbuild.tal1> echo '"OpenSSL 1.1.1t  7 Feb 2023"' | cut -f 2 -d\"
+		# OpenSSL 1.1.1t  7 Feb 2023
+		# harlan@ntp-testbuild.tal1> grep OPENSSL_VERSION_TEXT /ntpbuild/include/openssl/opensslv.h
+		# # define OPENSSL_VERSION_TEXT    "OpenSSL 1.1.1t  7 Feb 2023"
+		# harlan@ntp-testbuild.tal1>
+		##
+
+	    else
+		# This is a hack, but it's reasonable.
+		pkgpath="`echo $PATH_OPENSSL | sed -e 's:/bin/openssl$::'`/lib/pkgconfig"
+		test -d "$pkgpath" || pkgpath=
+		# echo "pkgpath is <$pkgpath>"
+		# echo "PKG_CONFIG_PATH is <$PKG_CONFIG_PATH>"
+		case "$pkgpath" in
+		 '') ;;	# Nothing to see here...
+		 *) case ":$PKG_CONFIG_PATH:" in
+		     ::)
+			PKG_CONFIG_PATH=$pkgpath
+			export PKG_CONFIG_PATH
+			;;
+		     *:$pkgpath:*)
+			# Already there...
+			;;
+		     *)
+			PKG_CONFIG_PATH="$pkgpath:$PKG_CONFIG_PATH"
+			export PKG_CONFIG_PATH
+			;;
+		    esac
+		    ;;
+		esac
+	    fi
+	    ;;
+        esac
+    done
+    ##EO
+
+    for pkg in `echo $with_crypto | $SED -e 's/,/ /'`; do
 	AC_MSG_CHECKING([pkg-config for $pkg])
 	if $PKG_CONFIG --exists $pkg ; then
-	    CPPFLAGS_NTP="$CPPFLAGS_NTP `$PKG_CONFIG --cflags-only-I $pkg`"
-	    CFLAGS_NTP="$CFLAGS_NTP `$PKG_CONFIG --cflags-only-other $pkg`"
-	    LDADD_NTP="$LDADD_NTP `$PKG_CONFIG --libs-only-L $pkg`"
-	    LDADD_NTP="$LDADD_NTP `$PKG_CONFIG --libs-only-l --static $pkg`"
-	    LDFLAGS_NTP="$LDFLAGS_NTP `$PKG_CONFIG --libs-only-other $pkg`"
-	    VER_SUFFIX=o
+	    ntp_ssl_cppflags="`$PKG_CONFIG --cflags-only-I $pkg`"
+	    case "$ntp_ssl_cppflags" in
+	     '')
+		ntp_ssl_incdir='not needed'
+		;;
+	     *)
+		ntp_ssl_incdir="`echo $ntp_ssl_cppflags | $SED -e 's/-I//'`"
+	    esac
+	    ntp_ssl_cflags="`$PKG_CONFIG --cflags-only-other $pkg`"
+	    ntp_ssl_libs_L="`$PKG_CONFIG --libs-only-L $pkg`"
+	    case "$ntp_ssl_libs_L" in
+	     '')
+		ntp_ssl_libdir='not needed'
+		;;
+	     *)
+		ntp_ssl_libdir="`echo $ntp_ssl_libs_L | $SED -e 's/-L//'`"
+	    esac
+	    ntp_ssl_libs_l="`$PKG_CONFIG --libs-only-l $pkg`"
+	    ntp_ssl_libs="$ntp_ssl_libs_L $ntp_ssl_libs_l"
+	    ntp_ssl_ldflags="`$PKG_CONFIG --libs-only-other $pkg`"
 	    ntp_openssl=yes
 	    ntp_openssl_from_pkg_config=yes
 	    ntp_openssl_version="`$PKG_CONFIG --modversion $pkg`"
@@ -96,184 +248,304 @@ case "$with_crypto:${PKG_CONFIG:+notempty}:${with_openssl_libdir-notgiven}:${wit
 	fi
 	AC_MSG_RESULT([no])
     done
+    AS_UNSET([pkg])
 esac
-dnl AC_MSG_NOTICE([OpenSSL Phase I checks:])
-dnl AC_MSG_NOTICE([CPPFLAGS_NTP: $CPPFLAGS_NTP])
-dnl AC_MSG_NOTICE([CFLAGS_NTP: $CFLAGS_NTP])
-dnl AC_MSG_NOTICE([LDADD_NTP: $LDADD_NTP])
-dnl AC_MSG_NOTICE([LDFLAGS_NTP: $LDFLAGS_NTP])
-case "$with_crypto:$ntp_openssl" in
- no:*) ;;
- *:no)
-    need_dash_r=
-    need_dash_Wlrpath=
-    case "${with_rpath-notgiven}" in
-     yes)
-	# Lame - what to do if we need -Wl... but not -R?
-	need_dash_r=1
-	;;
-     notgiven)
-	case "$host" in
-	 *-*-linux*)
-	    # This may really only be true for gcc
-	    need_dash_Wlrpath=1
-	    ;;
-	 *-*-netbsd*)
-	    need_dash_r=1
-	    ;;
-	 *-*-solaris*)
-	    need_dash_r=1
-	    ;;
-	esac
-	;;
-    esac
-
-    AC_MSG_CHECKING([for openssl library directory])
-    with_openssl_libdir=${with_openssl_libdir-notgiven}
+case "$with_crypto" in
+ no) ;;
+ *)
     case "$with_openssl_libdir" in
-     notgiven)
-	case "$build" in
-	 $host)
-	    with_openssl_libdir=default
-	    ;;
-	 *)
-	    with_openssl_libdir=no
-	    ;;
-	esac
+     '') ;;
+     *)
+	ntp_ssl_libdir="$with_openssl_libdir"
+	ntp_ssl_libs_L="-L$with_openssl_libdir"
+	ntp_ssl_libs_l="-lcrypto"
+	ntp_ssl_libs="$ntp_ssl_libs_L $ntp_ssl_libs_l"
     esac
-    case "$with_openssl_libdir" in
-     default)
-	# Look in:
-	with_openssl_libdir="/usr/lib /usr/lib/openssl /usr/sfw/lib"
-	with_openssl_libdir="$with_openssl_libdir /usr/local/lib"
-	with_openssl_libdir="$with_openssl_libdir /usr/local/ssl/lib /lib"
+    case "$with_openssl_incdir" in
+     '') ;;
+     *)
+	ntp_ssl_incdir="$with_openssl_incdir"
+	ntp_ssl_cppflags="-I$with_openssl_incdir"
     esac
-    case "$with_openssl_libdir" in
-     no)
+esac
+
+NTP_OPENSSL_VERBOSE_MSG([OpenSSL Phase I checks:])
+NTP_OPENSSL_VERBOSE_MSG([CPPFLAGS_NTP: ($CPPFLAGS_NTP)])
+NTP_OPENSSL_VERBOSE_MSG([CFLAGS_NTP:   ($CFLAGS_NTP)])
+NTP_OPENSSL_VERBOSE_MSG([LDADD_NTP:    ($LDADD_NTP)])
+NTP_OPENSSL_VERBOSE_MSG([LDFLAGS_NTP:  ($LDFLAGS_NTP)])
+NTP_OPENSSL_VERBOSE_MSG([ntp_openssl_from_pkg_config: $ntp_openssl_from_pkg_config])
+NTP_OPENSSL_VERBOSE_MSG([ntp_ssl_incdir:   ($ntp_ssl_incdir)])
+NTP_OPENSSL_VERBOSE_MSG([ntp_ssl_libdir:   ($ntp_ssl_libdir)])
+NTP_OPENSSL_VERBOSE_MSG([ntp_ssl_cflags:   ($ntp_ssl_cflags)])
+NTP_OPENSSL_VERBOSE_MSG([ntp_ssl_cppflags: ($ntp_ssl_cppflags)])
+NTP_OPENSSL_VERBOSE_MSG([ntp_ssl_libs_L:   ($ntp_ssl_libs_L)])
+NTP_OPENSSL_VERBOSE_MSG([ntp_ssl_libs_l:   ($ntp_ssl_libs_l)])
+NTP_OPENSSL_VERBOSE_MSG([ntp_ssl_libs:     ($ntp_ssl_libs)])
+NTP_OPENSSL_VERBOSE_MSG([ntp_ssl_ldflags:  ($ntp_ssl_ldflags)])
+
+case "$with_crypto" in
+ no)
+    ntp_openssl=no
+    ;;
+ *)
+    ntp_ssl_libs_l="${ntp_ssl_libs_l:--lcrypto}"
+    ntp_ssl_libs="$ntp_ssl_libs_L $ntp_ssl_libs_l"
+    case "$ntp_ssl_libdir" in
+     '')
+	dnl ### set ntp_ssl_libdir ###
+
+	dnl unconventional, using AC_CHECK_LIB repeatedly, clear cached result.
+	AS_UNSET([ac_cv_lib_crypto_EVP_MD_CTX_new])
+	AC_MSG_NOTICE([Searching for libcrypto without -L])
+	AC_CHECK_LIB(
+	    [crypto],
+	    [EVP_MD_CTX_new],
+	    [ntp_ssl_libdir='not needed']
+	)
+	dnl unconventional, using AC_CHECK_LIB repeatedly, clear cached result.
+	AS_UNSET([ac_cv_lib_crypto_EVP_MD_CTX_new])
+    esac
+    case "$ntp_ssl_libdir" in
+     '')
+	ntp_ssl_libdir_search="/usr/lib /usr/lib/openssl /usr/sfw/lib"
+	ntp_ssl_libdir_search="$ntp_ssl_libdir_search /usr/local/lib"
+	ntp_ssl_libdir_search="$ntp_ssl_libdir_search /usr/local/ssl/lib"
+	ntp_ssl_libdir_search="$ntp_ssl_libdir_search /opt/local/lib"
+	ntp_ssl_libdir_search="$ntp_ssl_libdir_search /lib /lib64"
 	;;
-     *) # Look for libcrypto.a and libssl.a:
-	for i in $with_openssl_libdir no
+     *)
+	ntp_ssl_libdir_search="$ntp_ssl_libdir"
+    esac
+    case $ntp_ssl_libdir_search in
+     'not needed') ;;
+     *)
+	for i in $ntp_ssl_libdir_search not_found
 	do
-	    case "$host" in
-	     *-*-darwin*)
-		test -f $i/libcrypto.dylib -a -f $i/libssl.dylib && break
-		;;
+	    case "$i" in
+	     not_found) ;;
 	     *)
-		test -f $i/libcrypto.so -a -f $i/libssl.so && break
-		test -f $i/libcrypto.a -a -f $i/libssl.a && break
-		;;
+		AC_MSG_NOTICE([Searching for libcrypto in $i])
+		LIBS="-L$i $NTPSSL_SAVED_LIBS"
+		AC_CHECK_LIB(
+		    [crypto],
+		    [EVP_MD_CTX_new],
+		    [break]
+		)
+		dnl unconventional, using AC_CHECK_LIB repeatedly, clear cached result.
+		AS_UNSET([ac_cv_lib_crypto_EVP_MD_CTX_new])
 	    esac
 	done
-	openssl_libdir=$i
-	;;
-    esac
-    AC_MSG_RESULT([$openssl_libdir])
-    case "$openssl_libdir" in
-     no)
-	openssl_libdir=
-	AC_MSG_WARN([libcrypto and libssl not found in any of $with_openssl_libdir])
+	ntp_ssl_libdir="$i"
+	ntp_ssl_libs_L="-L$i"
+	ntp_ssl_libs="$ntp_ssl_libs_L $ntp_ssl_libs_l"
+	LIBS="$NTPSSL_SAVED_LIBS"
+	case "$ntp_ssl_libdir" in
+	 not_found)
+	    AC_MSG_ERROR(
+[You may want to use --without-crypto, or add 
+openssl.pc/libcrypto.pc to PKG_CONFIG_PATH, or use the 
+--with-openssl-libdir=/some/path option to configure.
+libcrypto not found in any of the following directories:
+$ntp_ssl_libdir_search]
+	    )
+	esac
+	AC_MSG_NOTICE([libcrypto found in $ntp_ssl_libdir])
     esac
 
-    AC_MSG_CHECKING([for openssl include directory])
-    with_openssl_incdir=${with_openssl_incdir-notgiven}
-    case "$with_openssl_incdir" in
-     notgiven)
-	# Look in:
-	with_openssl_incdir="/usr/include /usr/sfw/include"
-	with_openssl_incdir="$with_openssl_incdir /usr/local/include"
-	with_openssl_incdir="$with_openssl_incdir /usr/local/ssl/include"
+    case "$ntp_openssl_from_pkg_config:$ntp_ssl_incdir" in
+     'yes:not needed' | no:)
+	AC_MSG_NOTICE([Searching for openssl/evp.h without -I])
+	dnl force uncached AC_CHECK_HEADER
+	AS_UNSET([ac_cv_header_openssl_evp_h])
+	AC_CHECK_HEADER(
+	    [openssl/evp.h],
+	    [ntp_ssl_incdir='not needed']
+	    )
     esac
-    case "$with_openssl_incdir" in
-     no)
+    case "$ntp_ssl_incdir" in
+     'not needed')
+	ntp_ssl_incdir_search="$ntp_ssl_incdir"
 	;;
-     *) # look for openssl/evp.h:
-	for i in $with_openssl_incdir no
-	do
-	    test -f $i/openssl/evp.h && break
-	done
-	openssl_incdir=$i
-	;;
-    esac
-    AS_UNSET([i])
-    AC_MSG_RESULT([$openssl_incdir])
-    case "$openssl_incdir" in
-     no)
-	openssl_incdir=
-	AC_MSG_WARN([did not find openssl/evp.h in any of $with_openssl_incdir])
-    esac
-    if test -z "$openssl_libdir" -o -z "$openssl_incdir"
-    then
-	ntp_openssl=no
-    else
-	ntp_openssl=yes
-	VER_SUFFIX=o
-    fi
-    case "$ntp_openssl" in
-     yes)
-	# We have OpenSSL inc/lib dirs - use them.
-	case "$openssl_incdir" in
-	 /usr/include)
+     *)
+	AC_MSG_NOTICE([Searching for openssl include directory])
+	case "$with_openssl_incdir" in
+	 '')
+	    case "$ntp_ssl_incdir" in
+	     '')
+		ntp_ssl_incdir_search="/usr/include /usr/sfw/include"
+		ntp_ssl_incdir_search="$ntp_ssl_incdir_search /usr/local/include"
+		ntp_ssl_incdir_search="$ntp_ssl_incdir_search /opt/local/include"
+		ntp_ssl_incdir_search="$ntp_ssl_incdir_search /usr/local/ssl/include"
+		;;
+	     *)
+	    esac
 	    ;;
 	 *)
-	    CPPFLAGS_NTP="$CPPFLAGS_NTP -I$openssl_incdir"
-	    ;;
+	    ntp_ssl_incdir_search="$with_openssl_incdir"
 	esac
-	case "$openssl_libdir" in
-	 /usr/lib)
-	    ;;
+	case $ntp_ssl_incdir_search in
+	 'not needed') ;;
 	 *)
-	    LDADD_NTP="$LDADD_NTP -L$openssl_libdir"
-	    case "$need_dash_r" in
-	     1)
-		LDFLAGS_NTP="$LDFLAGS_NTP -R$openssl_libdir"
+	    for i in $ntp_ssl_incdir_search
+	    do
+		AC_MSG_NOTICE([Searching for openssl/evp.h in $i])
+		CPPFLAGS="$NTPSSL_SAVED_CPPFLAGS -I$i"
+		dnl force uncached AC_CHECK_HEADER
+		AS_UNSET([ac_cv_header_openssl_evp_h])
+		AC_CHECK_HEADER(
+		    [openssl/evp.h],
+		    [ntp_ssl_incdir="$i" ; break]
+		    )
+	    done
+	    AS_UNSET([ac_cv_header_openssl_evp_h])
+	    AS_UNSET([i])
+	    CPPFLAGS="$NTPSSL_SAVED_CPPFLAGS"
+	    case "$ntp_ssl_incdir" in
+	     '')
+		AC_MSG_ERROR(
+[You may want to use --without-crypto, or add
+openssl.pc/libcrypto.pc to PKG_CONFIG_PATH, or use the
+-with-openssl-incdir=/some/path option to configure.
+No usable openssl/evp.h found in any of the following direcotries:
+$ntp_ssl_incdir_search]
+		)
 	    esac
-	    case "$need_dash_Wlrpath" in
-	     1)
-		LDFLAGS_NTP="$LDFLAGS_NTP -Wl,-rpath,$openssl_libdir"
-	    esac
-	    ;;
+	    ntp_ssl_cppflags="-I$ntp_ssl_incdir"
+	    AC_MSG_NOTICE([Found evp.h in $ntp_ssl_incdir/openssl])
 	esac
-	LDADD_NTP="$LDADD_NTP -lcrypto"
     esac
-esac
-
-AC_MSG_CHECKING([if we will use crypto])
-AC_MSG_RESULT([$ntp_openssl])
+    ntp_openssl=yes
+esac	dnl building with SSL ($with_crypto not "no")
 
-case "$ntp_openssl" in
- yes)
-    AC_CHECK_HEADERS([openssl/cmac.h openssl/hmac.h])
-    AC_DEFINE([OPENSSL], [], [Use OpenSSL?])
-    case "$VER_SUFFIX" in
-     *o*) ;;
-     *) AC_MSG_ERROR([OPENSSL set but no 'o' in VER_SUFFIX!]) ;;
-    esac
+case "$ntp_openssl:$ntp_ssl_libdir" in
+ 'yes:not needed')
     ;;
-esac
+ yes:*)
+    CFLAGS="$NTPSSL_SAVED_CFLAGS $ntp_ssl_cflags"
+    CPPFLAGS="$NTPSSL_SAVED_CPPFLAGS $ntp_ssl_cppflags"
+    LIBS="$ntp_ssl_libs $NTPSSL_SAVED_LIBS"
+    LDFLAGS="$ntp_ssl_ldflags $NTPSSL_SAVED_LDFLAGS"
+    dnl ### test if runpath is needed for crypto ###
+    AC_CACHE_CHECK(
+	[if crypto works without runpath],
+	[ntp_cv_ssl_without_runpath],
+	[AC_RUN_IFELSE(
+	    [AC_LANG_PROGRAM(
+		[[
+		    #include "openssl/evp.h"
+		]],
+		[[
+		    if (!EVP_MD_CTX_new()) {
+			return 1;
+		    }
+		]]
+	    )],
+	    [ntp_cv_ssl_without_runpath=yes],
+	    [ntp_cv_ssl_without_runpath=no],
+	    [ntp_cv_ssl_without_runpath=yes]		dnl cross-compile
+	)]
+    )
+    case "$ntp_cv_ssl_without_runpath" in
+     no)
+	AC_CACHE_CHECK(
+	    [if crypto needs -Wl,-rpath,$ntp_ssl_libdir],
+	    [ntp_cv_ssl_needs_dashWl_rpath],
+	    [
+		LDFLAGS="$ntp_ssl_ldflags -Wl,-rpath,$ntp_ssl_libdir $NTPSSL_SAVED_LDFLAGS"
+		AC_RUN_IFELSE(
+		    [AC_LANG_PROGRAM(
+			[[
+			    #include "openssl/evp.h"
+			]],
+			[[
+			    if (!EVP_MD_CTX_new()) {
+				return 1;
+			    }
+			]]
+		    )],
+		    [ntp_cv_ssl_needs_dashWl_rpath=yes],
+		    [ntp_cv_ssl_needs_dashWl_rpath=no]
+		)
+	    ]
+	)
+	case "$ntp_cv_ssl_needs_dashWl_rpath" in
+	 yes)
+	    ntp_ssl_ldflags="$ntp_ssl_ldflags -Wl,-rpath,$ntp_ssl_libdir"
+	    ;;
+	 no)
+	    AC_CACHE_CHECK(
+		[if crypto needs -R$ntp_ssl_libdir],
+		[ntp_cv_ssl_needs_dashR],
+		[
+		    LDFLAGS="$NTPSSL_SAVED_LDFLAGS $ntp_ssl_ldflags -R$ntp_ssl_libdir"
+		    AC_RUN_IFELSE(
+			[AC_LANG_PROGRAM(
+			    [[
+				#include "openssl/evp.h"
+			    ]],
+			    [[
+				if (!EVP_MD_CTX_new()) {
+				    return 1;
+				}
+			    ]]
+			)],
+			[ntp_cv_ssl_needs_dashR=yes],
+			[ntp_cv_ssl_needs_dashR=no]
+		    )
+		]
+	    )
+	    case "$ntp_cv_ssl_needs_dashR" in
+	     yes)
+		ntp_ssl_ldflags="$ntp_ssl_ldflags -R$ntp_ssl_libdir"
+	    esac
+	    case "$build:$ntp_cv_ssl_needs_dashR" in
+	     $host:no)
+		AC_MSG_FAILURE(
+[Unable to run program using crypto, check openssl.pc
+or libcrypto.pc are in PKG_CONFIG_PATH, or provide the
+ --with-openssl-libdir=/some/path option to configure.]
+		)
+	    esac
+	esac
+    esac
+esac	dnl ntp_openssl was yes
 
-NTPO_SAVED_CPPFLAGS="$CPPFLAGS"
-CPPFLAGS="$CPPFLAGS $CPPFLAGS_NTP"
-NTPO_SAVED_LIBS="$LIBS"
+NTP_OPENSSL_VERBOSE_MSG([OpenSSL Phase II checks:])
+NTP_OPENSSL_VERBOSE_MSG([ntp_ssl_incdir:   ($ntp_ssl_incdir)])
+NTP_OPENSSL_VERBOSE_MSG([ntp_ssl_libdir:   ($ntp_ssl_libdir)])
+NTP_OPENSSL_VERBOSE_MSG([ntp_ssl_cflags:   ($ntp_ssl_cflags)])
+NTP_OPENSSL_VERBOSE_MSG([ntp_ssl_cppflags: ($ntp_ssl_cppflags)])
+NTP_OPENSSL_VERBOSE_MSG([ntp_ssl_libs_L:   ($ntp_ssl_libs_L)])
+NTP_OPENSSL_VERBOSE_MSG([ntp_ssl_libs_l:   ($ntp_ssl_libs_l)])
+NTP_OPENSSL_VERBOSE_MSG([ntp_ssl_libs:     ($ntp_ssl_libs)])
+NTP_OPENSSL_VERBOSE_MSG([ntp_ssl_ldflags:  ($ntp_ssl_ldflags)])
 
-#
-# check for linking with -lcrypto failure, and try -lcrypto -lz.
-# Helps m68k-atari-mint
-#
+dnl check for linking with -lcrypto failure, and try -lcrypto -lz.
+dnl Helps m68k-atari-mint
+dnl
+dnl Needs work with the changes to run-test whether runpath is needed.
+dnl Probably needs to be moved ahead of runpath testing.
+dnl hart@ is reaching out to MiNT users to try to find a tester.
+dnl Meanwhile can be forced by passing both ntp_cv_bare_lcrypto=no
+dnl and ntp_cv_lcrypto_lz=yes on the configure command line.
+dnl
 case "$ntp_openssl:$ntp_openssl_from_pkg_config" in
  yes:no)
-    LIBS="$NTPO_SAVED_LIBS $LDADD_NTP"
+    CFLAGS="$NTPSSL_SAVED_CFLAGS $ntp_ssl_cflags"
+    CPPFLAGS="$NTPSSL_SAVED_CPPFLAGS $ntp_ssl_cppflags"
+    LIBS="$ntp_ssl_libs $NTPSSL_SAVED_LIBS"
+    LDFLAGS="$ntp_ssl_ldflags $NTPSSL_SAVED_LDFLAGS"
     AC_CACHE_CHECK(
-	[if linking with -lcrypto alone works],
+	[if linking with $ntp_ssl_libs_l alone works],
 	[ntp_cv_bare_lcrypto],
 	[AC_LINK_IFELSE(
 	    [AC_LANG_PROGRAM(
 		[[
-		    #include "openssl/err.h"
 		    #include "openssl/evp.h"
 		]],
 		[[
-		    ERR_load_crypto_strings();
-		    OpenSSL_add_all_algorithms();
+		    EVP_MD_CTX_new();
 		]]
 	    )],
 	    [ntp_cv_bare_lcrypto=yes],
@@ -282,19 +554,17 @@ case "$ntp_openssl:$ntp_openssl_from_pkg_config" in
     )
     case "$ntp_cv_bare_lcrypto" in
      no)
-	LIBS="$NTPO_SAVED_LIBS $LDADD_NTP -lz"
+	LIBS="-$ntp_ssl_libs -lz $NTPSSL_SAVED_LIBS"
 	AC_CACHE_CHECK(
-	    [if linking with -lcrypto -lz works],
+	    [if linking with $ntp_ssl_libs_l -lz works],
 	    [ntp_cv_lcrypto_lz],
 	    [AC_LINK_IFELSE(
 		[AC_LANG_PROGRAM(
 		    [[
-			#include "openssl/err.h"
 			#include "openssl/evp.h"
 		    ]],
 		    [[
-			ERR_load_crypto_strings();
-			OpenSSL_add_all_algorithms();
+			EVP_MD_CTX_new();
 		    ]]
 		)],
 		[ntp_cv_lcrypto_lz=yes],
@@ -303,103 +573,160 @@ case "$ntp_openssl:$ntp_openssl_from_pkg_config" in
 	)
 	case "$ntp_cv_lcrypto_lz" in
 	 yes)
-	     LDADD_NTP="$LDADD_NTP -lz"
+	     ntp_ssl_libs_l="$ntp_ssl_libs_l -lz"
+	     ntp_ssl_libs="$ntp_ssl_libs_L $ntp_ssl_libs_l"
 	esac
-    esac
-esac
-
-#
-# Older OpenSSL headers have a number of callback prototypes inside
-# other function prototypes which trigger copious warnings with gcc's
-# -Wstrict-prototypes, which is included in -Wall.
-#
-# An example:
-#
-# int i2d_RSA_NET(const RSA *a, unsigned char **pp, 
-#		  int (*cb)(), int sgckey);
-#		  ^^^^^^^^^^^
-#
-# 
-#
-openssl_triggers_warnings=unknown
-NTPO_SAVED_CFLAGS="$CFLAGS"
+    esac	dnl linking with -lcrypto alone fails
+esac		dnl using SSL and not from pkg-config
 
+dnl
+dnl Older OpenSSL headers have a number of callback prototypes inside
+dnl other function prototypes which trigger copious warnings with gcc's
+dnl -Wstrict-prototypes, which is included in -Wall.
+dnl
+dnl An example:
+dnl
+dnl int i2d_RSA_NET(const RSA *a, unsigned char **pp, 
+dnl		  int (*cb)(), int sgckey);
+dnl		  ^^^^^^^^^^^
+dnl
 case "$ntp_openssl:$GCC" in
  yes:yes)
-    CFLAGS="$CFLAGS -Werror"
-    AC_COMPILE_IFELSE(
-	[AC_LANG_PROGRAM(
-	    [[
-	    ]],
-	    [[
-		/* see if -Werror breaks gcc */
-	    ]]
-	)],
-	[gcc_handles_Werror=yes],
-	[gcc_handles_Werror=no]
+    CFLAGS="$NTP_SAVED_CFLAGS $ntp_ssl_cflags -Werror"
+    CPPFLAGS="$NTPSSL_SAVED_CPPFLAGS $ntp_ssl_cppflags"
+    LIBS="$ntp_ssl_libs $NTPSSL_SAVED_LIBS"
+    LDFLAGS="$ntp_ssl_ldflags $NTPSSL_SAVED_LDFLAGS"
+    AC_CACHE_CHECK(
+	[If $CC supports -Werror],
+	[ntp_cv_gcc_supports_Werror],
+	[AC_COMPILE_IFELSE(
+	    [AC_LANG_PROGRAM([], [])],
+	    [ntp_cv_gcc_supports_Werror=yes],
+	    [ntp_cv_gcc_supports_Werror=no]
+	)]
     )
-    case "$gcc_handles_Werror" in
+    case "ntp_cv_gcc_supports_Werror" in
      no)
-	# if this gcc doesn't do -Werror go ahead and use
-	# -Wstrict-prototypes.
-	openssl_triggers_warnings=yes
+	ntp_use_Wstrict_prototypes=yes
 	;;
      yes)
 	CFLAGS="$CFLAGS -Wstrict-prototypes"
-	AC_COMPILE_IFELSE(
-	    [AC_LANG_PROGRAM(
-		[[
-		    #include "openssl/asn1_mac.h"
-		    #include "openssl/bn.h"
-		    #include "openssl/err.h"
-		    #include "openssl/evp.h"
-		    #include "openssl/pem.h"
-		    #include "openssl/rand.h"
-		    #include "openssl/x509v3.h"
-		]],
-		[[
-		    /* empty body */
-		]]
-	    )],
-	    [openssl_triggers_warnings=no],
-	    [openssl_triggers_warnings=yes]
+	AC_CACHE_CHECK(
+	    [if OpenSSL triggers warnings],
+	    [ntp_cv_ssl_triggers_warnings],
+	    [AC_COMPILE_IFELSE(
+		[AC_LANG_PROGRAM(
+		    [[
+			#include "openssl/asn1_mac.h"
+			#include "openssl/bn.h"
+			#include "openssl/err.h"
+			#include "openssl/evp.h"
+			#include "openssl/pem.h"
+			#include "openssl/rand.h"
+			#include "openssl/x509v3.h"
+		    ]],
+		    [[
+			/* empty body */
+		    ]]
+		)],
+		[ntp_cv_ssl_triggers_warnings=no],
+		[ntp_cv_ssl_triggers_warnings=yes]
+	    )]
 	)
+	case "$ntp_cv_ssl_triggers_warnings" in
+	 yes)
+	    ntp_use_Wstrict_prototypes=no
+	    ;;
+	 *)
+	    ntp_use_Wstrict_prototypes=yes
+	esac
     esac
-    case "$openssl_triggers_warnings" in
-     yes)
-	CFLAGS_NTP="$CFLAGS_NTP -Wno-strict-prototypes"
+    case "$ntp_use_Wstrict_prototypes" in
+     no)
+	ntp_ssl_cflags="$ntp_ssl_cflags -Wno-strict-prototypes"
 	;;
      *)
-	CFLAGS_NTP="$CFLAGS_NTP -Wstrict-prototypes"
+	ntp_ssl_cflags="$ntp_ssl_cflags -Wstrict-prototypes"
     esac
     ;;
  no:yes)
-    # gcc without OpenSSL
-    CFLAGS_NTP="$CFLAGS_NTP -Wstrict-prototypes"
-esac
+    dnl gcc without OpenSSL
+    ntp_ssl_cflags="$ntp_ssl_cflags -Wstrict-prototypes"
+esac	dnl checking for gcc problems with -Werror and -Wstrict-prototypes
 
-# Because we don't want -Werror for the EVP_MD_do_all_sorted check
-CFLAGS="$NTPO_SAVED_CFLAGS"
+AC_MSG_CHECKING([if we will link to ssl library])
+AC_MSG_RESULT([$ntp_openssl])
 
 case "$ntp_openssl" in
  yes)
-    LIBS="$NTPO_SAVED_LIBS $LDADD_NTP"
+    VER_SUFFIX=o
+    AC_CHECK_HEADERS(
+	[openssl/cmac.h],
+	[ntp_enable_cmac=yes],
+	[ntp_enable_cmac=no]
+    )
+    case "$ntp_enable_cmac" in
+     yes)
+    	AC_DEFINE([ENABLE_CMAC], [1], [Enable CMAC support?])
+    esac
+    AC_DEFINE([OPENSSL], [], [Use OpenSSL?])
+    dnl OpenSSL 3 deprecates a bunch of functions used by Autokey.
+    dnl Adapting our code to the bold new way is not a priority
+    dnl for us because we do not want to require OpenSSL 3 yet.
+    dnl The deprecation warnings clutter up the build output
+    dnl encouraging the habit of ignoring warnings.
+    dnl So, tell it to the hand, OpenSSL deprecation warnings...
+    AC_DEFINE([OPENSSL_SUPPRESS_DEPRECATED], [1],
+	      [Suppress OpenSSL 3 deprecation warnings])
+    dnl We don't want -Werror for the EVP_MD_do_all_sorted check
+    CFLAGS="$NTPSSL_SAVED_CFLAGS"
     AC_CHECK_FUNCS([EVP_MD_do_all_sorted])
-    ;;
+    CPPFLAGS_NTP="$CPPFLAGS_NTP $ntp_ssl_cppflags"
+    CFLAGS_NTP="$CFLAGS_NTP $ntp_ssl_cflags"
+    LDADD_NTP="$ntp_ssl_libs $LDADD_NTP"
+    LDFLAGS_NTP="$ntp_ssl_ldflags $LDFLAGS_NTP"
 esac
 
-dnl AC_MSG_NOTICE([OpenSSL final checks:])
-dnl AC_MSG_NOTICE([CPPFLAGS_NTP: $CPPFLAGS_NTP])
-dnl AC_MSG_NOTICE([CFLAGS_NTP: $CFLAGS_NTP])
-dnl AC_MSG_NOTICE([LDADD_NTP: $LDADD_NTP])
-dnl AC_MSG_NOTICE([LDFLAGS_NTP: $LDFLAGS_NTP])
+NTP_OPENSSL_VERBOSE_MSG([OpenSSL final checks:])
+NTP_OPENSSL_VERBOSE_MSG([ntp_openssl:  $ntp_openssl])
+NTP_OPENSSL_VERBOSE_MSG([CPPFLAGS_NTP: ($CPPFLAGS_NTP)])
+NTP_OPENSSL_VERBOSE_MSG([CFLAGS_NTP:   ($CFLAGS_NTP)])
+NTP_OPENSSL_VERBOSE_MSG([LDADD_NTP:    ($LDADD_NTP)])
+NTP_OPENSSL_VERBOSE_MSG([LDFLAGS_NTP:  ($LDFLAGS_NTP)])
+
+CFLAGS="$NTPSSL_SAVED_CFLAGS"
+CPPFLAGS="$NTPSSL_SAVED_CPPFLAGS"
+LIBS="$NTPSSL_SAVED_LIBS"
+LDFLAGS="$NTPSSL_SAVED_LDFLAGS"
 
-CPPFLAGS="$NTPO_SAVED_CPPFLAGS"
-LIBS="$NTPO_SAVED_LIBS"
-AS_UNSET([NTPO_SAVED_CFLAGS])
-AS_UNSET([NTPO_SAVED_CPPFLAGS])
-AS_UNSET([NTPO_SAVED_LIBS])
-AS_UNSET([openssl_triggers_warnings])
+AS_UNSET([NTPSSL_SAVED_CFLAGS])
+AS_UNSET([NTPSSL_SAVED_CPPFLAGS])
+AS_UNSET([NTPSSL_SAVED_LIBS])
+AS_UNSET([NTPSSL_SAVED_LDFLAGS])
+AS_UNSET([ntp_enable_cmac])
+AS_UNSET([ntp_use_Wstrict_prototypes])
 AS_UNSET([ntp_openssl_from_pkg_config])
+AS_UNSET([ntp_openssl_version])
+AS_UNSET([ntp_ssl_cflags])
+AS_UNSET([ntp_ssl_cppflags])
+AS_UNSET([ntp_ssl_libdir_search])
+AS_UNSET([ntp_ssl_incdir_search])
+AS_UNSET([ntp_ssl_libdir])
+AS_UNSET([ntp_ssl_incdir])
+AS_UNSET([ntp_ssl_libs_l])
+AS_UNSET([ntp_ssl_libs_L])
+AS_UNSET([ntp_ssl_ldflags])
+
 ])
+dnl end of AC_DEFUN([NTP_OPENSSL])
+dnl
+AC_DEFUN(
+    [NTP_OPENSSL_VERBOSE_MSG],
+    [dnl
+	case "$enable_verbose_ssl" in
+	 yes) AC_MSG_NOTICE([$1])
+	esac
+    ]
+)
+dnl
 dnl ======================================================================
diff --git a/contrib/ntp/sntp/m4/version.m4 b/contrib/ntp/sntp/m4/version.m4
index 95deaa41c695..add8fc6018cb 100644
--- a/contrib/ntp/sntp/m4/version.m4
+++ b/contrib/ntp/sntp/m4/version.m4
@@ -1 +1 @@
-m4_define([VERSION_NUMBER],[4.2.8p17])
+m4_define([VERSION_NUMBER],[4.2.8p18])
diff --git a/contrib/ntp/sntp/main.c b/contrib/ntp/sntp/main.c
index 08064a6c0eaa..b1a35b42a431 100644
--- a/contrib/ntp/sntp/main.c
+++ b/contrib/ntp/sntp/main.c
@@ -1010,12 +1010,12 @@ kill_asyncio(
 		sock6 = INVALID_SOCKET;
 	}
 	if (INVALID_SOCKET != bsock4) {
-		closesocket(sock4);
-		sock4 = INVALID_SOCKET;
+		closesocket(bsock4);
+		bsock4 = INVALID_SOCKET;
 	}
 	if (INVALID_SOCKET != bsock6) {
-		closesocket(sock6);
-		sock6 = INVALID_SOCKET;
+		closesocket(bsock6);
+		bsock6 = INVALID_SOCKET;
 	}
 }
 #endif
@@ -1033,9 +1033,9 @@ worker_resp_cb(
 {
 	blocking_child *	c;
 
-	DEBUG_INSIST(EV_READ & what);
+	REQUIRE(EV_READ & what);
 	c = ctx;
-	DEBUG_INSIST(fd == c->resp_read_pipe);
+	INSIST(fd == c->resp_read_pipe);
 	process_blocking_resp(c);
 }
 
@@ -1060,7 +1060,7 @@ intres_timeout_req(
 		ev_worker_timeout = event_new(base, -1,
 					      EV_TIMEOUT | EV_PERSIST,
 					      &worker_timeout, NULL);
-		DEBUG_INSIST(NULL != ev_worker_timeout);
+		INSIST(NULL != ev_worker_timeout);
 	} else {
 		event_del(ev_worker_timeout);
 	}
@@ -1082,7 +1082,7 @@ worker_timeout(
 	UNUSED_ARG(fd);
 	UNUSED_ARG(ctx);
 
-	DEBUG_REQUIRE(EV_TIMEOUT & what);
+	REQUIRE(EV_TIMEOUT & what);
 	worker_idle_timer_fired();
 }
 
@@ -1144,8 +1144,8 @@ generate_pkt (
 	}
 	if (pkt_key != NULL) {
 		x_pkt->exten[0] = htonl(key_id);
-		mac_size = make_mac(x_pkt, pkt_len, MAX_MDG_LEN,
-				    pkt_key, (char *)&x_pkt->exten[1]);
+		mac_size = make_mac(x_pkt, pkt_len, pkt_key,
+				    (char *)&x_pkt->exten[1], MAX_MDG_LEN);
 		if (mac_size > 0)
 			pkt_len += mac_size + KEY_MAC_LEN;
 #ifdef DEBUG
